adinstbpm - Task #17844

Milestone # 17719 (New): Booster operational test of one crate alongside existing BPM system

Locking mechanism for shared memory objects
10/09/2017 09:54 AM - John Diamond

Status: Resolved Start date: 10/09/2017
Priority: Normal Due date:

Assignee: John Diamond % Done: 100%
Category: Estimated time: 12.00 hours
Target version: Spent time: 3.00 hours
Description

Implement a locking mechanism for records stored in a SharedMemoryTable.

History

#1 - 10/09/2017 10:04 AM - John Diamond

We can base this design on process-shared POSIX semaphores:

https://linux.die.net/man/7/sem_overview

#2 - 10/10/2017 01:40 PM - John Diamond
- Status changed from Assigned to Resolved

- % Done changed from 0 to 100

Created a template class called SHMClient<> that will lock the mutex inside the Record structure of the template parameter. The template parameter
must provide a method called mutexGet() to provide access to the mutex.

Added locks to the ACNET code, cli code and DAQSystem code that deals with the shared memory Reading tables.
